//+------------------------------------------------------------------+
//|                                                  TradeTester.mq4 |
//|                Copyright  2010, Forex Trading Laboratory Kirin. |
//|                                           http://www.ftlabo.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Forex Trading Laboratory Kirin."
#property link      "http://www.ftlabo.com/"
#import "TradeTesterDll.dll"
double AskRead();
void AskWrite(double);
double BidRead();
void BidWrite(double);
void StopLevelWrite(double);
int OrderTypeRead();
void OrderTypeWrite(int);
double OrderLimitRead();
void OrderLimitWrite(double);
double OrderStopRead();
void OrderStopWrite(double);
int PreOrderTypeRead();
void PreOrderTypeWrite(int);
int PreOrderKindRead();
void PreOrderKindWrite(int);
double PreOrderPriceRead();
void PreOrderPriceWrite(double);
double PreOrderLimitRead();
void PreOrderLimitWrite(double);
double PreOrderStopRead();
void PreOrderStopWrite(double);
#import

#import "shell32.dll"
int ShellExecuteA(int handle, string , string , string, string, int);
#import

double POINT;
string EX;

// ̖̐F
color ArrowColor[6] = {Blue, Red, Blue, Red, Blue, Red};
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   double stopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if(Digits==3 || Digits==5){
      stopLevel/=10;
      POINT = Point*10;
   }else{
      POINT = Point;
   }
   StopLevelWrite(stopLevel);
   
   Print(ShellExecuteA(0, "open", TerminalPath()+"\\experts\\libraries\\TradeTester.exe", "", "",10));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
int Ticket;
int Position;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   EX="";
   
   AskWrite(Ask);
   BidWrite(Bid);
   
   if(OrdersTotal()==0)Position=0;
   
   int orderType = OrderTypeRead();
   double orderLimit = OrderLimitRead();
   double orderStop  = OrderStopRead();
   
   int preOrderType=0;
   int preOrderKind=0;
   double preOrderPrice=0;
   double preOrderLimit=0;
   double preOrderStop=0;
   
   if(orderType != 0 || Position !=0){
      PreOrderTypeWrite(0);
      PreOrderKindWrite(0);
   }else{
      preOrderType = PreOrderTypeRead();
      preOrderKind = PreOrderKindRead();
      preOrderPrice = PreOrderPriceRead();
      preOrderLimit = PreOrderLimitRead();
      preOrderStop  = PreOrderStopRead();
   }
   
   CommentEX("orderLimit"+orderLimit);
   CommentEX("orderStop"+orderStop);
   
   double limit=0;
   double stop=0;
   double order;
   int type;
   
   if(orderType == 1 && Position == 0) {
      if(orderLimit!=0)limit = NormalizeDouble(Ask+orderLimit*POINT, Digits);
      if(orderStop!=0)stop  = NormalizeDouble(Ask-orderStop*POINT, Digits);
      Ticket = OrderSend(Symbol(), OP_BUY, 0.1, NormalizeDouble(Ask, Digits), 10, stop, limit, "Buy", 1234, 0, Blue);
      Position = 1;
      OrderTypeWrite(0);
   }
   if(orderType == 2 && Position == 0){
      if(orderLimit!=0)limit = NormalizeDouble(Bid-orderLimit*POINT, Digits);
      if(orderStop!=0)stop  = NormalizeDouble(Bid+orderStop*POINT, Digits);
      Ticket = OrderSend(Symbol(), OP_SELL, 0.1, NormalizeDouble(Bid, Digits), 10, stop, limit, "Sell", 1234, 0, Red);
      Position = -1;
      OrderTypeWrite(0);
   }

   if(preOrderType == 1 && Position == 0) {      
      if(preOrderKind==1){
         order = NormalizeDouble(Ask-preOrderPrice*POINT, Digits);
         type = OP_BUYLIMIT;
      }
      if(preOrderKind==2){
         order = NormalizeDouble(Ask+preOrderPrice*POINT, Digits);
         type = OP_BUYSTOP;
      }
      if(preOrderLimit!=0)limit = NormalizeDouble(order+preOrderLimit*POINT, Digits);
      if(preOrderStop!=0)stop  = NormalizeDouble(order-preOrderStop*POINT, Digits);
      CommentEX("order : "+order);
      CommentEX("limit : "+limit);
      CommentEX("stop : "+stop);
      CommentEX("type : "+type);
      Ticket = OrderSend(Symbol(), type, 0.1, order, 10, stop, limit, "Buy", 1234, 0, Blue);
      Position = 2;
      PreOrderTypeWrite(0);
      PreOrderKindWrite(0);
   }
   if(preOrderType == 2 && Position == 0){
      if(preOrderKind==1){
         order = NormalizeDouble(Bid+preOrderPrice*POINT, Digits);
         type = OP_SELLLIMIT;
      }
      if(preOrderKind==2){
         order = NormalizeDouble(Bid-preOrderPrice*POINT, Digits);
         type = OP_SELLSTOP;
      }
      if(preOrderLimit!=0)limit = NormalizeDouble(order-preOrderLimit*POINT, Digits);
      if(preOrderStop!=0)stop  = NormalizeDouble(order+preOrderStop*POINT, Digits);
      Ticket = OrderSend(Symbol(), type, 0.1, order, 10, stop, limit, "Sell", 1234, 0, Red);
      Position = -2;
      PreOrderTypeWrite(0);
      PreOrderKindWrite(0);
   }
   
   if(orderType == -1 && Position == 1){
      FTLOrderClose(3,1234);
      FTLOrderDelete(1234);
      Position = 0;
      Ticket = 0;
      OrderTypeWrite(0);
   }
   if(orderType == -1 && Position == -1){
      FTLOrderClose(3,1234);
      FTLOrderDelete(1234);
      Position = 0;
      Ticket = 0;
      OrderTypeWrite(0);
   }
   
   if(orderType == -1 && Position == 2){
      if(!FTLOrderDelete(1234))FTLOrderClose(3,1234);;
      Position = 0;
      Ticket = 0;
      OrderTypeWrite(0);
   }
   if(orderType == -1 && Position == -2){
      if(!FTLOrderDelete(1234))FTLOrderClose(3,1234);;
      Position = 0;
      Ticket = 0;
      OrderTypeWrite(0);
   }
   
   ObjectDelete("AskLine");
   ObjectCreate("AskLine",OBJ_HLINE,0, 0, Ask);
   ObjectSet("AskLine", OBJPROP_COLOR, White);
   ObjectSet("AskLine", OBJPROP_STYLE, STYLE_SOLID);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//fobNpRg
void CommentEX(string comment){
   EX = EX + comment + "\n";
   Comment(EX);
}

// I[v|WVς
bool FTLOrderClose(int slippage, int magic, int type = -1)
{
   int ticket = 0;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS) == false) break;
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != magic) continue;
      int odrtype = OrderType();
      if( type == -1 &&(odrtype == OP_BUY || odrtype == OP_SELL))
      {
         ticket = OrderTicket();
         break;
      }else if(odrtype == type){
         ticket = OrderTicket();
         break;
      }
      
   }
   if(ticket == 0) return(false);

   int starttime = GetTickCount();
   while(true)
   {
      if(GetTickCount() - starttime > 10*1000)
      {
         Alert("OrderClose timeout. Check the experts log.");
         return(false);
      }
      if(IsTradeAllowed() == true)
      {
         RefreshRates();
         if(OrderClose(ticket, OrderLots(), NormalizeDouble(OrderClosePrice(),Digits), slippage, ArrowColor[odrtype]) == true) return(true);
      }
      Sleep(100);
   }
   return(false);
}

// ҋ@LZ
bool FTLOrderDelete(int magic)
{
   int ticket = 0;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS) == false) break;
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != magic) continue;
      int type = OrderType();
      if(type != OP_BUY && type != OP_SELL)
      {
         ticket = OrderTicket();
         break;
      }
   }
   if(ticket == 0) return(false);

   int starttime = GetTickCount();
   while(true)
   {
      if(GetTickCount() - starttime > 1*1000)
      {
         Alert("OrderDelete timeout. Check the experts log.");
         return(false);
      }
      if(IsTradeAllowed() == true)
      {
         if(OrderDelete(ticket) == true) return(true);
      }
      Sleep(100);
   }
   return(false);
}